package
{
	import org.flixel.FlxG;
	import org.flixel.FlxGroup;
	import org.flixel.FlxObject;
	import org.flixel.FlxPoint;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class BaseLevel extends FlxState
	{
		protected static const NUM_PLANETS:uint = 5;
		
		protected var planets:Vector.<Planet>;
		protected var meteorite:Meteorite;
		
		protected var planetsGrp:FlxGroup;
		protected var sun:Sun;
		
		public function BaseLevel()
		{
			super();
			
			FlxG.bgColor = 0xff000000;
			
			planetsGrp = new FlxGroup();
			planets = new Vector.<Planet>();
			add( planetsGrp );
			
			/*
			sun = new Sun( 320, 240, 10 );
			add( sun );
			
			for ( var i:uint=0; i < NUM_PLANETS; i++ )
			{
				planets.push( new Planet( Math.random() * FlxG.width, Math.random() * FlxG.height, 5 + Math.random() * 20 ) );
				planetsGrp.add( planets[i] );
			}
			
			
			*/
			
			meteorite = new Meteorite();
			add( meteorite );
			
		}
		
		override public function update():void
		{
			super.update();
			
			var gravity:Number = 10;
			
			// the meteorite is the cursor
			meteorite.x = FlxG.mouse.x;
			meteorite.y = FlxG.mouse.y;
			
			for each ( var planet:Planet in planets )
			{
				var dist:Number = FlxU.getDistance( new FlxPoint( planet.x, planet.y ), new FlxPoint( meteorite.x, meteorite.y ) );
				
				var o2:RoundThing = planet;
				var o1:RoundThing = sun;
				
				if (dist >= o1.radius + o2.radius) 
				{
					o2.velocity.x += (o1.x - o2.x) / Math.pow(dist, 2) * gravity;
					o2.velocity.y += (o1.y - o2.y) / Math.pow(dist, 2) * gravity;
					//o2.x += o2.velocity.x;
					//o2.y += o2.velocity.y;
				} 
				else 
				{
					o2.velocity.x = o2.velocity.y = 0;
				}
			}
			
			FlxG.collide( meteorite, planetsGrp );
			FlxG.collide( planetsGrp, planetsGrp );
			
		}
		
		private function onMeteoriteCollide( flx1:FlxObject, flx2:FlxObject ):void
		{
			var planet:Planet = flx1 as Planet;
			if( planet == null )
			{
				planet = flx2 as Planet;
			}
			
			if( planet == null )
			{
				return;
			}
			
			planet.velocity.x += ( meteorite.x - planet.x ) / 10; 
			planet.velocity.y += ( meteorite.y - planet.y ) / 10; 
					
		}
		
	}
}